/*
 * GNUTrekCGIlib 0.2   --   http://www.trek.eu.org/trekcgi/?lib
 * Copyright (C) 1999,2000 Trek <trek@mediaservice.net> <trek00@freenet.hut.fi>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
 * or see http://www.opensource.org/licenses/gpl-license.html
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "trekcgilib.h"


int extract_env(char **env, char *keyword, char *value, int valuesize)
{
	int i, keywordlen;

	keywordlen = strlen(keyword);

	for(i=0; env[i] != NULL; i++)
		if(!strncmp(env[i], keyword, keywordlen) && env[i][keywordlen] == '=') {
			strncpy(value, (env[i] + keywordlen + 1), valuesize);
			value[valuesize-1]=0;
			return(0);
		}
	return(-1);
}


int convertstr(char *querystr, char *outstr, int outsize)
{
	int i, val;
	char *ptr = querystr;
	static char bufval[3];

	/* scan while end of string or buffer overflow */
	for (i=0; ((char)*ptr != 0) && (i < outsize); ptr++, i++) {
		switch ((char)*ptr) {
		case '+':	/* space */
			outstr[i] = ' ';
			break;

		case '%':	/* exadecimal character */
			strncpy(bufval, ptr+1, 2);
			bufval[2] = 0;
			sscanf(bufval, "%x", &val);
			ptr+=2;
			outstr[i] = (char)val;
			break;

		default:	/* normal contents */
			outstr[i] = (char)*ptr;
			break;
		}
	}
	outstr[i] = 0;
	return(i);
}


char **parsequery(char *querystr, char **queryp)
{
	int i, elements, querylen;
	char *ptr = querystr,
	     *buff, *bufout;

	/* alloc memory sizes like querystr lenght */
	querylen = strlen(querystr);
	if (((buff=(char *)malloc(querylen*sizeof(char))) == NULL) ||
	   ((bufout=(char *)malloc(querylen*sizeof(char))) == NULL) ||
	   ((queryp=(char **)malloc(sizeof(char *))) == NULL))
		return(NULL);

	/* scan while end of string or line feed */
	for (elements=i=0; ((char)*ptr != 0) && ((char)*ptr != '\n'); ptr++) { 
		if ((char)*ptr == '&') {
			/* end of variable then store */
			buff[i] = 0;
			i = convertstr(buff, bufout, querylen);
			queryp = (char **)realloc(queryp, (elements+1)*sizeof(char *));
			queryp[elements] = (char *)malloc((i+1)*sizeof(char));
			strncpy(queryp[elements], bufout, i);
			queryp[elements][i]=0;
			elements++;
			i = 0;
		} else {
			/* content of variable */
			buff[i] = (char)*ptr;
			i++;
		}
	}

	/* store last variable and add a stop in the array */
	buff[i] = 0;
	i = convertstr(buff, bufout, querylen);
	queryp = (char **)realloc(queryp, (elements+1)*sizeof(char *));
	queryp[elements] = (char *)malloc((i+1)*sizeof(char));
	strncpy(queryp[elements], bufout, i);
	queryp[elements][i]=0;
	queryp[elements+1] = NULL;

	/* don't waste memory */
	free(buff);
	free(bufout);
	return(queryp);
}


int allowchars(char *inputstr, char *chars)
{
	int i, j;

	for (i=0; inputstr[i] != 0; i++) {
		for (j=0; chars[j] != 0; j++)
			if (inputstr[i] == chars[j])
				break;
		/* if no character allowed found return error */
		if(chars[j] == 0)
			return(-1);
	}
	return(0);
}

